/*
   This file defines a Box class. A Box object holds data
   that describes the dimensions of a box, i.e., length, width,
   and height values. We can send four different messages to a
   Box object. They messages (or methods) are volume(), area(),
   lengthPlusGirth(), and writeOutput(). Notice that the first
   three messages all return a result, but the last message does
   not return a result (it is a "void" method). The writeOutput()
   message prints some results on the output screen, but "printing
   results" is not what we mean when we say that a method "returns
   a result". It is important to remember this distinction.

   Can you think of any other "properties" (i.e. data) that could be
   associated with a Box object? Try adding a new property to this class.
   Can you think of any other messages that a Box object should accept?
*/

class Box
{
   // Three instance variables. Notice how these
   // variables are "inside" the Box class, but not
   // "inside" of any method.
   public double length;
   public double width;
   public double height;


   // Define an instance method to compute volume.
   public double volume()
   {
      return length * width * height;
   }


   // Define an instance method to compute surface area.
   public double area()
   {
      double top   = length * width;
      double side2 = height * length;
      double side1 = height * width;

      return 2*top + 2*side1 + 2*side2;
   }


   // Define an instance method to compute "length plus girth".
   public double lengthPlusGirth()
   {
      // put the length, width, and height in temporary variables
      double l = length;
      double w = width;
      double h = height;

      // the "length" should be the largest dimension of the box
      if (w > l)
      {
         // if "width" is larger than "length"
         // then swap the two values
         double temp = l;
         l = w;
         w = temp;
      }
      if (h > l)
      {
         // if "height" is larger than "length"
         // then swap the two values
         double temp = l;
         l = h;
         h = temp;
      }
      return l + 2*w + 2*h;
   }//lengthPlusGirth


   // Define an instance method that prints out the data in a box object.
   public void writeOutput()
   {
      System.out.println("This box has the following dimensions:");
      System.out.println("\tlength = " + length);
      System.out.println("\twidth  = " + width);
      System.out.println("\theight = " + height);
   }

}//Box
